open Taml;;
open Dxn;;
open Colapsing_v3;;

let rtl _ = 
print_string "
====================================================================================================
=== Application of ARTMC on RTL model verification
====================================================================================================
   ";
let sigma_str = "s:0 i:1 f:1 d:1 e:1 eh:1 r:1 o:1" in
let init_str = "
  States p
  Final States p 
  Transitions
    s->p i(p)->p" in
let tau_str = 
  (["q0"; "q1"; "q2"; "q3"; "q4"; "q5"; "q6"], ["q0"; "q1"; "q2"; "q3"; "q4"; "q5"; "q6"],
    [
        ("s", [], "s", "q0");
        ("o", ["q0"], "o", "q0");
        ("i", ["q0"], "f", "q1");
        ("f", ["q0"], "d", "q2");
        ("d", ["q0"], "e", "q3");
        ("d", ["q0"], "eh","q3");
        ("e", ["q0"], "r", "q4");
        ("r", ["q0"], "o", "q5");
        ("eh",["q0"], "o", "q6");

        ("i", ["q1"], "i", "q1"); ("f", ["q1"], "f", "q1"); ("d", ["q1"], "d", "q1"); ("e", ["q1"], "e", "q1"); ("eh",["q1"], "eh","q1"); ("r", ["q1"], "r", "q1"); ("o", ["q1"], "o", "q1");
        ("i", ["q2"], "f", "q1");                           ("d", ["q2"], "d", "q2"); ("e", ["q2"], "e", "q2"); ("eh",["q2"], "eh","q2"); ("r", ["q2"], "r", "q2"); ("o", ["q2"], "o", "q2");
        ("i", ["q3"], "f", "q1"); ("f", ["q3"], "d", "q2");                           ("e", ["q3"], "e", "q3"); ("eh",["q3"], "eh","q3"); ("r", ["q3"], "r", "q3"); ("o", ["q3"], "o", "q3");

(*e/r*) ("i", ["q4"], "f", "q1"); ("f", ["q4"], "d", "q2"); ("d", ["q4"], "e", "q3"); ("d", ["q4"], "d", "q3");                           ("r", ["q4"], "r", "q4"); ("o", ["q4"], "o", "q4");
(*r/o*) ("i", ["q5"], "f", "q1"); ("f", ["q5"], "d", "q2"); ("d", ["q5"], "e", "q3"); ("d", ["q5"], "eh","q3"); ("e", ["q5"], "r", "q4"); ("eh",["q5"], "o", "q6"); ("o", ["q5"], "o", "q5");
(*eh/o*)("i", ["q6"], "f", "q1"); ("f", ["q6"], "d", "q2"); ("d", ["q6"], "e", "q3"); ("d", ["q6"], "eh","q3");                           ("r", ["q6"], "r", "q6"); ("o", ["q6"], "o", "q6");
    ]) in
let bad_str = "
  States p0 p1 p2
  Final States p2
  Transitions
    s->p0
    i(p0)->p0 f(p0)->p0 d(p0)->p0 e(p0)->p0 r(p0)->p1 o(p0)->p0
    i(p1)->p1 f(p1)->p1 d(p1)->p1 eh(p1)->p2 r(p1)->p1 o(p1)->p1
    i(p2)->p2 f(p2)->p2 d(p2)->p2 e(p2)->p2 r(p2)->p2 o(p2)->p2" in
let sigstar_str = "
  States p
  Final States p
  Transitions
    s->p
    i(p)->p f(p)->p d(p)->p e(p)->p r(p)->p o(p)->p" in

print_endline" atrmc_strpres_fwcomp_bwcoll_allstpred sigma_str init_str tau_str bad_str [ sigstar_str ] ";
atrmc_strpres_fwcomp_bwcoll_allstpred sigma_str init_str tau_str bad_str [ sigstar_str ];
()
